import PagerDigitalController from '../controller/PagerDigital.js';

class PagerDigital {
  register(server) {
    server.post('/order', async(req, res) => {
      try {
        const response = await PagerDigitalController.startOrder(req);
        res.send(response);
      } catch (error) {
        res.status(500).send({ message: error.message });
      }
    });

    server.get('/order/:orderId', async(req, res) => {
      try {
        if (!req.params || !req.params.orderId) {
          throw new Error('{orderId} not informed');
        }
        let response = {};
        if (req.query.onlyStatus) {
          response = await PagerDigitalController.orderTracking(req.params.orderId);
        } else {
          response = await PagerDigitalController.findOrder(req.params.orderId);
        }
        res.send(response);
      } catch (error) {
        res.status(500).send({ message: error.message });
      }
    });

    server.put('/order/:orderId', async(req, res) => {
      try {
        const response = await PagerDigitalController.updateOrder(req.params.orderId);
        res.send(response);
      } catch (error) {
        res.status(500).send({ message: error.message });
      }
    });
  }
}

export default new PagerDigital();
