import Base64 from '../helper/Base64.js';
import Security from './Security.js';

class Auth {
  async isValidBasicAuth(authorization) {
    let authorized = false;
    let reason = 'VALID_CREDENTIALS';
    if (typeof authorization === 'string' && authorization.startsWith('Basic')) {
      const credential = Base64.decode(authorization.replace('Basic ', ''), false);
      const [username = '', password = ''] = credential?.split(':') || [];
      authorized = await Security.isAuthorizedUser(username, password);
      reason = 'INVALID_CREDENTIALS';
    } else {
      reason = 'NOT_FOUND_CREDENTIALS';
    }
    return { authorized, reason };
  }

}

export default new Auth();
